# -*- coding: utf-8 -*-

import logging
import argparse

from ydl_ai_recommender.src.core.db_data_manager import DBDataManager
from ydl_ai_recommender.src.core.profile_manager import ProfileManager


logging.basicConfig(
    format='%(asctime)s - %(levelname)s - %(name)s - %(message)s',
    datefmt='%m/%d/%Y %H:%M:%S',
    level=logging.INFO
)

parser = argparse.ArgumentParser(description='壹点灵 咨询师推荐 算法召回')

parser.add_argument('--index_last_date', default=None, type=str, help='构建索引最后日期，超过该日期的数据不使用')

# 数据自动备份
# 新建索引数据


# 更新索引


# 性能测试
    # 的

parser.add_argument(
    '-t', '--task', type=str, required=True,
    choices=('load_db_data', 'make_profile_index', 'do_test'), help='执行任务名称'
)
parser.add_argument('--test_start_date', default='-3', type=str, help='测试任务 - 开始日期')
parser.add_argument('--test_end_date', default='0', type=str, help='测试任务 - 结束日期')


parser.add_argument('--batch_size', default=128, type=int, help='训练时一个 batch 包含多少条数据')
parser.add_argument('--learning_rate', default=1e-3, type=float, help='Adam 优化器的学习率')
parser.add_argument('--add_special_tokens', default=True, type=bool, help='bert encode 时前后是否添加特殊token')
parser.add_argument('--num_train_epochs', default=2, type=int, help='训练时运行的 epoch 数量', )
parser.add_argument('--seed', type=int, default=42, help='随机数种子，保证结果可复现')
parser.add_argument('--do_train', action='store_true', default=False)
parser.add_argument('--do_test', action='store_true', default=False)
parser.add_argument('--do_predict', action='store_true', default=False)
args = parser.parse_args()


if __name__ == '__main__':
    if args.task == 'load_db_data':
        # 从数据库中导出信息
        manager = DBDataManager()
        manager.update_order_info()
        manager.update_profile()
    
    if args.task == 'make_profile_index':
        manager = ProfileManager()
        manager.make_embeddings()
        manager.make_virtual_embedding()

    if args.task == 'make_similarity':
        pass